# $Id$

package require msgcat

namespace eval reject_subscription {
    ::msgcat::mcload [file join [file dirname [info script]] msgs]
    custom::defgroup Plugins [::msgcat::mc "Plugins options."] -group Tkabber
    custom::defgroup {Reject subscription} \
	[::msgcat::mc "Reject subscription plugin options."] -group Plugins
    custom::defvar options(enable) 0 \
	[::msgcat::mc "Enable rejecting subscription if the contact is not in our roster."] \
	-type boolean -group {Reject subscription}
    custom::defvar options(log_file) [file join $::configdir reject_subscription.log] \
	[::msgcat::mc "Logfile for rejected subscription requests."] \
	-type file -group {Reject subscription}
}

proc reject_subscription::reply {xlib from type x args} {
    variable options

    if {!$options(enable)} return
    if {$type != "subscribe"} return

    set jid [::xmpp::jid::normalize $from]
    set rjid [roster::find_jid $xlib $jid]

    # It's OK if we already asked for a subscription or if we are already
    # subscribed
    if {$rjid != "" && \
	([roster::itemconfig $xlib $rjid -ask] == "subscribe" || \
	 [roster::itemconfig $xlib $rjid -subsc] != "none")} {
	return
    } else {
	::roster::remove_item $xlib $jid
	log_jid $xlib $jid
	return stop
    }
}

hook::add client_presence_hook [namespace current]::reject_subscription::reply 40

proc reject_subscription::log_jid {xlib jid} {
    variable options

    set fd [open $options(log_file) a]
    puts $fd "[clock format [clock seconds]]\t([connection_jid $xlib])\t$jid"
    close $fd
}

