# savebtn.tcl v0.2 20090501 (megaxbit@xmpp.ru)
namespace eval savebtn {
	::msgcat::mcload [file join [file dirname [info script]] msgs]

    if {![::plugins::is_registered savebtn]} {
	::plugins::register savebtn \
			    -namespace [namespace current] \
			    -source [info script] \
			    -description [::msgcat::mc savebtn] \
			    -loadcommand [namespace code load] \
			    -unloadcommand [namespace code unload]
	return
    }
}

proc savebtn::save_photo {jid sbtn} {
catch {
$sbtn configure -state disabled
set defname $jid
	for {set x 0} {$x<[string length $defname]} {incr x} {
		set s [string index $jid $x]
		if {$s == "\\" || $s == "/" || $s == ":" || $s == "*" \
			|| $s == "?" || $s == "<" || $s == ">" || $s == "|" || $s == "\""} {
			set defname [string replace $defname $x $x "_"]
		}
	}
	set photofile [tk_getSaveFile -initialfile $defname \
		-title [::msgcat::mc "Save photo"] -parent .]
	if {$photofile != ""} {
		set fileid [::open "$photofile.[string range $userinfo::userinfo(photo_type,$jid) 6 end]" w]
		fconfigure $fileid -translation binary
		puts $fileid $userinfo::userinfo(photo_binval,$jid)
		close $fileid
	}
$sbtn configure -state normal
}
}

proc savebtn::checkbtn {sbtn a b c} {
catch {$sbtn configure -state normal
trace vdelete "userinfo::$a\($b\)" $c "[namespace current]::checkbtn $sbtn"
}
}

proc savebtn::addbutton {tab connid jid editable} {
catch {
if {$editable == 0} {
	set p $tab.fphoto.photo.f
	grid $p.sw -row 1 -column 0 -sticky wens -columnspan 3 -pady 0.5m
	set sbtn [button $p.savebtn -text [::msgcat::mc "Save photo"] \
		-command [list [namespace current]::save_photo $jid $p.savebtn] -state disabled]
	grid $sbtn -row 0 -column 2
	trace variable userinfo::userinfo(photo_type,$jid) w "[namespace current]::checkbtn $sbtn"
}
}
}
proc savebtn::load {} {
hook::add userinfo_hook [namespace current]::addbutton 40
}

proc savebtn::unload {} {
hook::remove userinfo_hook [namespace current]::addbutton 40
}

